#if !defined(AFX_MPEGDECCONTROLDLG_H__72F03C81_B245_11D2_940F_0000C03AAEB6__INCLUDED_)
#define AFX_MPEGDECCONTROLDLG_H__72F03C81_B245_11D2_940F_0000C03AAEB6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// MPEGDecControlDlg.h : header file
//


#define NUM_SUB_COMMANDS	2


typedef struct {
	int PlayControl;
	int StopControl;
	int PauseControl;
	int LoopControl;
	int OpenControl;
	int ClipNameControl;
	int StatusControl;
	int ChanLabelControl;
	int PlayModeControl;
	int StartModeControl;
	int StartOffsetTypeControl;
	int StartOffsetHiControl;
	int StartOffsetLoControl;
	int EndOffsetTypeControl;
	int EndOffsetHiControl;
	int EndOffsetLoControl;
	int TransitionBOSControl;
	int TransitionBOEOSControl;
	int TransitionFramesControl;
	int StartTimeControl;
	int AudioStreamIDControl;
} PANEL_IDS;

class CMpegStatus;

/////////////////////////////////////////////////////////////////////////////
// CMPEGDecControlDlg dialog

class CMPEGDecControlDlg : public CDialog
{
// Construction
public:
	CMPEGDecControlDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CMPEGDecControlDlg)
	enum { IDD = IDD_MPEG_CONTROL };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

	friend class CMpegStatus;
	CMpegStatus* m_pMpegStatus;
	ISTBTMPEGDecoderControl			*pMPEGDecoderControl;
	int m_CardNumber;

	UINT m_TimerID;

										// Playback options for each sub channel
	PLAY_OPTIONS m_PlayOptions[NUM_SUB_COMMANDS];
	char m_ClipPath[NUM_SUB_COMMANDS][MAX_PATH];// Currently selected clip to play
	DWORD m_hStream[NUM_SUB_COMMANDS];	// Stream handle

	DWORD m_FrameList[NUM_SUB_COMMANDS][MAX_FRAME_LIST_ENTRIES];// Frame list for each command 
	BOOL m_bFrameListEnabled[NUM_SUB_COMMANDS];					// TRUE if frame list is enabled
	int m_FrameListCount[NUM_SUB_COMMANDS];						// Number of entries in frame list

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMPEGDecControlDlg)
	public:
	virtual BOOL DestroyWindow();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HBITMAP hBitmapPlay, hBitmapPlayDisabled;
	HBITMAP hBitmapStop, hBitmapStopDisabled;
	HBITMAP hBitmapPause, hBitmapPauseDisabled;
	HBITMAP	hBitmapMuteOff, hBitmapMuteOn;
	HBITMAP hBitmapOpen;
	HBITMAP hBitmapLoop;

	BOOL m_bMuted;

	char* PrependCardID(char* buffer, char* string);

	void SelectClip(int command);
	void ShowClipName(int command);

	PLAY_MODE GetPlayMode(int command);
	void SetPlayMode(int command, PLAY_MODE PlayMode);
	START_MODE GetStartMode(int command);
	void SetPlayMode(int command, START_MODE StartMode);
	void GetStartOffset(int command, PMEDIA_OFFSET pOffset);
	void SetStartOffset(int command, PMEDIA_OFFSET pOffset);
	void GetEndOffset(int command, PMEDIA_OFFSET pOffset);
	void SetEndOffset(int command, PMEDIA_OFFSET pOffset);
	void GetTransitionOptions(int command, PTRANSITION_OPTIONS pOptions);
	void SetTransitionOptions(int command, PTRANSITION_OPTIONS pOptions);
	void SetStartTime(int command, DWORD StartTime);
	DWORD GetStartTime(int command);
	void SetAudioStreamID(int command, DWORD StreamID);
	DWORD GetAudioStreamID(int command);

	void OnFrameList(int command);
	TULSA_RESULT NotifyAtStatus(DWORD hStream, DWORD FrameNumber);


	void OnPlay(int command);
	void OnStop(int command);
	void OnPause(int command);
	void OnOpen(int command);
	void OnLoop(int command);

	void LoadCardButtonBitmaps(void);
	void UnLoadCardButtonBitmaps(void);
	void InitCardButtons(int CG_IDD, int CG_ID_VIEW, PANEL_IDS* pIDs, int command);
	void InitButtonStates();
	void SetButtonsToStopState(int command);
	void SetButtonsToPlayState(int command);

	LRESULT UpdateStatus(WPARAM wParam, LPARAM lParam);

	// Generated message map functions
	//{{AFX_MSG(CMPEGDecControlDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPlay1();
	afx_msg void OnStop1();
	afx_msg void OnPause1();
	afx_msg void OnLoop1();
	afx_msg void OnPlay2();
	afx_msg void OnStop2();
	afx_msg void OnPause2();
	afx_msg void OnLoop2();
	afx_msg void OnFrameListA();
	afx_msg void OnFrameListB();
	afx_msg void OnOpen1();
	afx_msg void OnOpen2();
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};



//////////////////////////////////////////////////////////////////////////
//  ISTBTMPEGStatus
//////////////////////////////////////////////////////////////////////////

class CMpegStatus : ISTBTMPEGStatus
{
public:
	CMpegStatus(CMPEGDecControlDlg *pParent) : m_pParent(pParent) {}
	CMPEGDecControlDlg *m_pParent;

     //*** IUnknown methods ***   
    CRefCount				m_cRef;   // object reference counter
    STDMETHODIMP            QueryInterface(REFIID riid, LPVOID FAR *ppv) 
										{ QUERY_MY_INTERFACE(IID_ISTBTMPEGStatus, ISTBTMPEGStatus) }
    STDMETHODIMP_(ULONG)    AddRef()	{ return(m_cRef.AddRef()); }
    STDMETHODIMP_(ULONG)    Release()	{ return(m_cRef.Release()); }
    /*** ISTBTMPEGStatus methods ***/
    STDMETHODIMP			NotifyAtStatus(
								DWORD hStream,
								DWORD FrameNumber);
    STDMETHODIMP			PlayStatus(
								DWORD hStream,
								PDECODE_STATUS pStatus);
};


//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MPEGDECCONTROLDLG_H__72F03C81_B245_11D2_940F_0000C03AAEB6__INCLUDED_)
